import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Bug here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bug  extends Moving
{
   
    public void init(){
        if(initialized == false){
            
            setAmmo(5);
            setMoveSpeed(1);
            setMoveTurnAngle(1);
            setStdMoveSpeed(1);
            setStdImage(new GreenfootImage("ladybug1.png"));
            
            initialized = true;
        }
    }
    
    /**
     * Act - do whatever the Moving wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act(){
        init();
        StatusUtil.parse(this);
        MoveUtil.setExactCoords(this);
        MoveUtil.keyboardMovement(this);
        MoveUtil.move(this);
        WeaponsUtil.keyFire(this, "space");
        if(InteractUtil.eats(this, Leaf.class)){
            Scoreboard s = (Scoreboard)getWorld().getObjects(Scoreboard.class).get(0);
            s.scoreInc(10);
        }
        if(InteractUtil.eats(this, Pik.class)){
            StatusUtil.setSpeedUp(this,350);
        }
    }
    
    public boolean focused(){
        List crabs = getObjectsInRange(vision, Crab.class);
        if(crabs.isEmpty()){
            focused = false;
        }else{
            Crab crab = (Crab)crabs.get(0);
            MoveUtil.turnAway(this, crab);
            moving = true;
            focused = true;
        }
        return focused;
    }
    
}
