import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MoveUtil here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MoveUtil  
{
    public static void keyboardMovement(Moving obj){
        if(Greenfoot.isKeyDown("up")){
            obj.moving = true;
        }else{
            obj.moving = false;
        }
        if(Greenfoot.isKeyDown("right")){
            obj.setRotation(obj.getRotation()+obj.getTurnSpeed());
        }
        if(Greenfoot.isKeyDown("left")){
            obj.setRotation(obj.getRotation()-obj.getTurnSpeed());
        }
    }

    public static void move(Moving obj){
        if(obj.moving){
            obj.exactX = obj.exactX+(Math.cos(Math.toRadians(obj.getRotation()))*obj.getMoveSpeed());
            obj.exactY = obj.exactY+(Math.sin(Math.toRadians(obj.getRotation()))*obj.getMoveSpeed());
            if(
                obj.exactX < 15
                ||
                obj.exactX > (obj.getWorld().getWidth()-15)
                ||
                obj.exactY < 65
                ||
                obj.exactY > (obj.getWorld().getHeight()-15)
            ){
                obj.setRotation(obj.getRotation()+180-((int)obj.getMoveTurnAngle()/2)+Greenfoot.getRandomNumber(obj.getMoveTurnAngle()));
            }else{
                obj.setLocation(
                    (int)(Math.round(obj.exactX)),
                    (int)(Math.round(obj.exactY))
                    );
            }
        }
    }
    
    public static void randomMovement(Moving obj){
        if(obj.focused()==false){
            if(obj.moving == false){
                if(Greenfoot.getRandomNumber(obj.waitToMoveRate)==0){
                    obj.moving = true;
                }
                if(Greenfoot.getRandomNumber(obj.waitTurnRate)==0){
                    obj.setRotation(obj.getRotation()-((int)obj.waitTurnAngle/2)+Greenfoot.getRandomNumber(obj.waitTurnAngle));
                }
            }else{
                if(Greenfoot.getRandomNumber(obj.moveToWaitRate)==0){
                    obj.moving = false;
                }
                if(Greenfoot.getRandomNumber(obj.moveTurnRate)==0){
                    obj.setRotation(obj.getRotation()-((int)obj.getMoveTurnAngle()/2)+Greenfoot.getRandomNumber(obj.getMoveTurnAngle()));
                }
            }
        }
    }
    
    public static void setExactCoords(Moving obj){
        if(obj.exactCoordsSet == false){
            obj.exactCoordsSet = true;
            obj.exactX = (double)obj.getX();
            obj.exactY = (double)obj.getY();
        }
    }
    
    public static void turnAway(Moving obj, Moving obj2){
        double dX = obj.getX()-obj2.getX();
        double dY = obj.getY()-obj2.getY();
        if(dX == 0){
            if(dY>0){
                obj.setRotation(90);
            }else{
                obj.setRotation(270);
            }
        }else{
            if(dX > 0){
                double x = dY/dX;
                obj.setRotation((int)(Math.toDegrees(Math.atan(x))));
            }else{
                double x = dY/dX;
                obj.setRotation(180+(int)(Math.toDegrees(Math.atan(x))));
            }
        }
    }
    
    public static void turnTowards(Moving obj, Moving obj2){
        double dX = obj.getX()-obj2.getX();
        double dY = obj.getY()-obj2.getY();
        if(dX == 0){
            if(dY>0){
                obj.setRotation(270);
            }else{
                obj.setRotation(90);
            }
        }else{
            if(dX > 0){
                double x = dY/dX;
                obj.setRotation(180+(int)(Math.toDegrees(Math.atan(x))));
            }else{
                double x = dY/dX;
                obj.setRotation((int)(Math.toDegrees(Math.atan(x))));
            }
        }
    }
}
