import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Moving here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Moving  extends Actor
{
    
    private int             ammo = 0;
    private boolean         fireKeyDown = false;
    private int             invincTimer = 0;
    private double          moveSpeed = 1.0;
    private int             moveTurnAngle = 45;
    private Class           shotClass = Shot.class;
    private int             speedUpTimer = 0;
    private GreenfootImage  stdImage;
    private double          stdMoveSpeed = 1.0;
    public int              vision = 100;
    
    protected boolean initialized = false;

    public boolean exactCoordsSet = false;
    public boolean focused = false;
    public boolean moving = true;
    public double exactX = 0.0;
    public double exactY = 0.0;
    public int moveToWaitRate = 80;
    public int moveTurnRate = 60;
    public int waitToMoveRate = 100;
    public int waitTurnAngle = 75;
    public int waitTurnRate = 50;
    
    // Ammonition
    public int getAmmo(){
        return ammo;
    }
    public void setAmmo(int a){
        ammo = a;
    }
    
    // Invincibility Timer
    public boolean getFireKeyDown(){
        return fireKeyDown;
    }
    public void setFireKeyDown(boolean down){
        fireKeyDown = down;
    }
    
    // Invincibility Timer
    public int getInvincTimer(){
        return invincTimer;
    }
    public void setInvincTimer(int i){
        invincTimer = i;
    }
    
    // Move Speed
    public double getMoveSpeed(){
        return moveSpeed;
    }
    public void setMoveSpeed(double m){
        moveSpeed = m;
    }
    
    // Move Turn Angle
    public int getMoveTurnAngle(){
        return moveTurnAngle;
    }
    public void setMoveTurnAngle(int m){
        moveTurnAngle = m;
    }
    
    // Shot Class
    public Class getShotClass(){
        return shotClass;
    }
    public void setShotClass(Class cls){
        shotClass = cls;
    }
    
    // Speed-Up Timer
    public int getSpeedUpTimer(){
        return speedUpTimer;
    }
    public void setSpeedUpTimer(int i){
        speedUpTimer = i;
    }
    
    // Standard Image
    public GreenfootImage getStdImage(){
        return stdImage;
    }
    public void setStdImage(GreenfootImage img){
        stdImage = img;
    }
    
    // Standard Move Speed
    public double getStdMoveSpeed(){
        return stdMoveSpeed;
    }
    public void setStdMoveSpeed(double sm){
        stdMoveSpeed = sm;
    }
    
    // Vision
    public double getVision(){
        return vision;
    }
    public void setVision(int v){
        vision = v;
    }
    
    public int getTurnSpeed(){
        return 3;
    }
    
    /**
     * Act - do whatever the Moving wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act(){
        MoveUtil.setExactCoords(this);
        MoveUtil.randomMovement(this);
        MoveUtil.move(this);
    }
    
    public boolean focused(){
        return false;
    }
    
    public List getObjectsInRangePublic(int radius){
        return getObjectsInRange(radius, null);
    }
    
    public List getObjectsInRangePublic(int radius, Class cls){
        return getObjectsInRange(radius, cls);
    }
    
}
