import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Crab here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Crab  extends Moving
{
    
    public void init(){
        if(initialized == false){
            
            setMoveSpeed(0.3);
            setStdMoveSpeed(0.3);
            setStdImage(new GreenfootImage("lobster.png"));
            setVision(130);
            
            initialized = true;
        }
    }

    public void act(){
        init();
        StatusUtil.parse(this);
        MoveUtil.setExactCoords(this);
        MoveUtil.randomMovement(this);
        MoveUtil.move(this);
        InteractUtil.eats(this, Bug.class);
        if(InteractUtil.eats(this, Pik.class)){
            StatusUtil.setSpeedUp(this,350);
        }
    }
    
    public boolean focused(){
        List bugs = getObjectsInRange(vision, Bug.class);
        if(bugs.isEmpty()==false){
            Bug bug = (Bug)bugs.get(0);
            MoveUtil.turnTowards(this, bug);
            moving = true;
            return true;
        }
        List piks = getObjectsInRange(vision, Pik.class);
        if(piks.isEmpty()==false){
            Pik pik = (Pik)piks.get(0);
            MoveUtil.turnTowards(this, pik);
            moving = true;
            return true;
        }
        return false;
    }
    
}
